

public class Test {

    public static void dispIter(pIterator i){
        while(i.hasNext()){
            System.out.println(""+i.next()+", ");
        }
    }

    public static void main(String[] args) throws Exception {

        /*
        Object[] arr = new Object[100];
        for(int i=0;i<arr.length;i++)
            arr[i] = (int)(Math.random()*100);
        pArrayIterator ai = new pArrayIterator(arr);
        
        pIterator ai = new pRangeIterator(1,20);

        /*
        pIterator ai = pIteratorUtils.map(new pCompute(){
            public Object f(Object o){
                return (int)(Math.random()*100);
            }
        },new pRangeIterator(1,20));
        */

        
        pIterator[] arr = new pIterator[10];
        for(int i=0;i<arr.length;i++){
            arr[i] = new pRangeIterator(i*10,i*10+10);
        }
        pIterator ai = new pIteratorIterator(   
            new pArrayIterator(arr)
        );

        pIterator a = pIteratorUtils.grep(new pCompute(){
            public Object f(Object o){
                int n = (Integer)o;
                return n % 2 == 0 ? true : null;
            }
        },ai);

        pIterator b = pIteratorUtils.map(new pCompute(){
            public Object f(Object o){
                return "["+o+"]";
            }
        },a);
        pIterator c = pIteratorUtils.map(new pCompute(){
            public Object f(Object o){
                return "<"+o+">";
            }
        },b);

        pIterator d = pIteratorUtils.map(new pCompute(){
            public Object f(final Object o){
                return new Thread(
                    // what if...
                    //  we call another computer to do
                    //  this job?
                    new Runnable(){
                        public void run(){
                            System.out.println(""+o+",");
                        }
                    }
                );
            }
        },c);

        pIterator e = pIteratorUtils.map(new pCompute(){
            public Object f(final Object o){
                ((Thread)o).start();
                return o;
            }
        },d);

        dispIter(e);

        //pIteratorUtils

    }
}
