
public class pIteratorUtils {

    // return an interator that returns elements
    // wtih applied computation.
    public static pIterator map(final pCompute c, final pIterator o){
        return new pIterator(){
            final pIterator in = o;
            final pCompute comp = c;
            public Object next(){
                return comp.f( in.next() );
            }
            public boolean hasNext(){
                return in.hasNext();
            }
        };
    }

    // return only those elements for which 
    // c returns a non-null value.
    public static pIterator grep(final pCompute c, final pIterator o){
        return new pIterator(){
            final pIterator in = o;
            final pCompute comp = c;
            Object intone = null;
            public Object next(){                
                if(intone == null)
                    hasNext();
                Object r = intone;
                intone = null;
                return r;
            }
            public boolean hasNext(){
                if(intone != null)
                    return true;
                while(in.hasNext()){
                    Object o = in.next();
                    if(comp.f(o) != null){
                        intone = o;
                        return true;
                    }
                }
                return false;
            }
        };
    }
}
